Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Industrial Quad Relay Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"iqr", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletIndustrialQuadRelay\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Turn relays alternating on/off 10 times with 100 ms delay", "*)"}],
   RowBox[{"For", "[", RowBox[{RowBox[{"i", "=", "0"}], ",", RowBox[{"i", "<", "10"}], ",", RowBox[{"i", "++"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Pause", "[", "0.1", "]"}], ";", "\[IndentingNewLine]", "iqr", "@", RowBox[{"SetValue", "[", RowBox[{"FromDigits", "[", RowBox[{RowBox[{"{", RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "2"}], "]"}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Pause", "[", "0.1", "]"}], ";", "\[IndentingNewLine]", "iqr", "@", RowBox[{"SetValue", "[", RowBox[{"FromDigits", "[", RowBox[{RowBox[{"{", RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "2"}], "]"}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Pause", "[", "0.1", "]"}], ";", "\[IndentingNewLine]", "iqr", "@", RowBox[{"SetValue", "[", RowBox[{"FromDigits", "[", RowBox[{RowBox[{"{", RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", "2"}], "]"}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Pause", "[", "0.1", "]"}], ";", "\[IndentingNewLine]", "iqr", "@", RowBox[{"SetValue", "[", RowBox[{"FromDigits", "[", RowBox[{RowBox[{"{", RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "2"}], "]"}], "]"}], "\[IndentingNewLine]"}]}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "iqr", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
