Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your NFC/RFID Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"nr", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletNFCRFID\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for state changed callback", "*)"}],
   RowBox[{RowBox[{"StateChangedCB", "[", RowBox[{"sender_", ",", "state_", ",", "idle_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletNFCRFID`STATEUREQUESTUTAGUIDUREADY"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Tag found\>\"", "]"}], ";", "\n", "\[IndentingNewLine]", RowBox[{"(*", " Write 16 byte to pages 5-8 ", "*)"}], "\[IndentingNewLine]", "dataWrite", "=", RowBox[{"{", RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", "10", ",", "11", ",", "12", ",", "13", ",", "14", ",", "15"}], "}"}], ";", "\[IndentingNewLine]", "sender", "@", RowBox[{"WritePage", "[", RowBox[{"5", ",", "dataWrite"}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Writing data...\>\"", "]"}], ";", "\[IndentingNewLine]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletNFCRFID`STATEUWRITEUPAGEUREADY"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"(*", " Request pages 5-8 ", "*)"}], "\[IndentingNewLine]", "sender", "@", RowBox[{"RequestPage", "[", "5", "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Requesting data...\>\"", "]"}], ";", "\[IndentingNewLine]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletNFCRFID`STATEUREQUESTUPAGEUREADY"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"(*", " Get and print pages 5-8 ", "*)"}], "\[IndentingNewLine]", "dataRead", "=", "sender", "@", RowBox[{"GetPage", "[", "]"}], ";", "\[IndentingNewLine]", "result", "=", RowBox[{"{", RowBox[{"ToString", "[", RowBox[{"dataRead", "[", RowBox[{"[", "1", "]"}], "]"}], "]"}], "}"}], ";", "\[IndentingNewLine]", RowBox[{"For", "[", RowBox[{RowBox[{"i", "=", "2"}], ",", RowBox[{"i", "<=", "16"}], ",", RowBox[{"++", "i"}], ",", RowBox[{"AppendTo", "[", RowBox[{"result", ",", RowBox[{"\"\< \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"dataRead", "[", RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Read data: [\>\"", "<>", RowBox[{"StringJoin", "[", "result", "]"}], "<>", "\"\<]\>\""}], "]"}], "\[IndentingNewLine]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{RowBox[{RowBox[{"IntegerDigits", "[", RowBox[{"state", ",", "2", ",", "8"}], "]"}], "[", RowBox[{"[", "2", "]"}], "]"}], "==", "1"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"(*", " All errors have bit 6 set ", "*)"}], "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Error: \>\"", "<>", RowBox[{"ToString", "[", "state", "]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"nr", "@", "StateChangedCallback"}], ",", "StateChangedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Select NFC Forum Type 2 tag", "*)"}],
   RowBox[{"nr", "@", RowBox[{"RequestTagID", "[", "BrickletNFCRFID`TAGUTYPEUTYPE2", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "nr", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
